/**************************************************************************************
 Copyright (c) 2002 The UbixOS Project
 All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this list of conditions, the following disclaimer and the list of authors.
Redistributions in binary form must reproduce the above copyright notice, this list of conditions, the following disclaimer and the list of authors
in the documentation and/or other materials provided with the distribution. Neither the name of the UbixOS Project nor the names of its
contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 $Id: syscall.c,v 1.21 2003/05/01 12:30:02 reddawg Exp $

**************************************************************************************/

#include <ubixos/syscall.h>
#include <ubixos/syscalls.h>
#include <ubixos/schedule.h>
#include <ubixos/types.h>
#include <ubixos/exec.h>
#include <ubixos/elf.h>
#include <ubixos/vitals.h>
#include <sys/video.h>
#include <vmm/paging.h>
#include <vmm/memory.h>
#include <ubixos/file.h>
#include <ubixfs/ubixfs.h>
#include <lib/string.h>

asm(
  ".globl _sysCall              \n"
  "_sysCall:                    \n"
  "  cmpl totalCalls,%eax       \n"
  "  jae invalidCall            \n"  
  "  push %ds                   \n"
  "  push %es                   \n"
  "  push %fs                   \n"
  "  pushl %edx                 \n"
  "  pushl %ecx                 \n"
  "  pushl %ebx                 \n"
  "  call *systemCalls(,%eax,4) \n"
  "  pushl %eax                 \n"
  "  popl %eax\n"
  "  popl %ebx\n"
  "  popl %ecx\n"
  "  popl %edx\n"
  "  pop %fs\n"
  "  pop %es\n"
  "  pop %ds\n"
  "  iret                       \n" /* Exit interrupt               */
  );

void invalidCall() {
  kprintf("Invalid Sys Call!\n");
  //_current->status = AVAILABLE;
  //schedule();
  }

void sysGetpid(int *pid) {
  *pid = _current->id;
  return;
  }

void sysGetUid(int *uid) {
  *uid = _current->uid;
  return;
  }

void sysGetGid(int *gid) {
  *gid = _current->gid;
  return;
  }

void sysSetUid(int uid,int *status) {
  if (_current->uid == 0x0) {
    _current->uid = uid;
    *status = 0x0;
    }
  else {
    *status = 1;
    }
  return;
  }

void sysSetGid(int gid,int *status) {
  if (_current->gid == 0x0) {
    _current->gid = gid;
    *status = 0x0;
    }
  else {
    *status = 1;
    }
  return;
  }  

void sysExit(int status) {
  endTask(_current->id);
  sched_yield();
  }

void sysCheckPid(int *ptr) {
  //kprintf("Check status: %d[", *ptr);
  if (NULL == getTask(*ptr)) {
    *ptr = 0;
  }
  else if ((getTask(*ptr)->status != STARTING) && (getTask(*ptr)->status != EMPTY) && (getTask(*ptr)->status != EXITING)) {
    *ptr = 1;
    }
  else {
    *ptr = 0;
    }
  //kprintf("%d]\n", *ptr);
  }

/************************************************************************

Function: void sysGetFreePage();
Description: Allocs A Page To The Users VM Space
Notes:

************************************************************************/  
void sysGetFreePage(long *ptr,int count) {
  *ptr = (long) getFreeVirtualPage(_current->id,count);
  return;
  }

void sysGetDrives(uInt32 *ptr) {
  *ptr = (uInt32)drives;
  return;
  }


void sysGetCwd(char *data) {
  sprintf(data,":@%s",_current->oInfo.container->mountPoint);
  return;
  }
